
/******************************************************************************
* MODULE     : keyw_assign.cc
* DESCRIPTION: Assignment and definition of interactive variables
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
namespace mmx {

void
evaluator_rep::evaluate_assign_1 () {
  // FIXME: should become routine of type 'forall(T) (Alias T,T)->Void'.
  evaluate_arg (car(trace)[1], KW_ASSIGN_2);
}

void
evaluator_rep::evaluate_assign_2 () {
  // INPUT: (assign_2, var, ...)
  value var= as_value (car (rem));
  if (is_func (var->type, MMX_ALIAS, 1)) {
    generic val= list (MMX_TRANSTYPE, car(trace)[2], var->type[1]);
    cur= val;
    rem= cons (KW_ASSIGN_3, rem);
    // OUTPUT: (val, assign_3, var, ...)
  }
  else error (car(trace)[1], "Not an alias");
}

void
evaluator_rep::evaluate_assign_3 () {
  // INPUT: (assign_3, val, var, cont, ...)
  value var = as_value (cadr (rem));
  value val = as_value (car (rem));
  car (var->val)= val->val;
  cur= caddr (rem);
  rem= cons (VAL_VOID, cdddr (rem));
  // OUTPUT: (cont, void, ...)
  trace= cdr (trace);
}

} // namespace mmx
