
/******************************************************************************
* MODULE     : keyw_transtype.cc
* DESCRIPTION: Transtyping
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <function.hh>
namespace mmx {

bool
is_type (generic g) {
  return
    (gentype (g) == VALUE_TYPE) &&
    (as_value (g)->type == MMX_CLASS);
}

static generic
identity (generic args) {
  return args[1];
}

void
evaluator_rep::evaluate_transtype_1 () {
  evaluate_args (KW_TRANSTYPE_2);
}

void
evaluator_rep::evaluate_transtype_2 () {
  // INPUT: (transtype_2, args, cont, ...)
  list l= as_list (car (rem));
  generic val = car (l);
  generic type= cadr (l);
  if (gentype (val) != VALUE_TYPE)
    error (val, "Not a value");
  else if (!is_type (type))
    error (type, "Not a type");
  else if (as_value (val) -> type == as_value (type) -> val) {
    cur= cadr (rem);
    rem= cons (val, cddr (rem));
    // OUTPUT: (cont, ret, ...)
    trace= cdr (trace);
  }
  else { // transtype by applying identity function
    generic t= as_value (type) -> val;
    value id (function ("id", identity), function_type (t, t));
    cur= list (id, val);
    rem= cdr (rem);
    // OUTPUT: (id(val), cont, ...)
    trace= cdr (trace);
  }
}

} // namespace mmx
