
/******************************************************************************
* MODULE     : token_symbols.hh
* DESCRIPTION: frequently used symbols
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __TOKEN_SYMBOLS_HH
#define __TOKEN_SYMBOLS_HH
#include <symbol.hh>
namespace mmx {

/******************************************************************************
* Primitives
******************************************************************************/

extern symbol MMX_ACCESS;
extern symbol MMX_AND;
extern symbol MMX_ASSIGN;
extern symbol MMX_BEGIN;
extern symbol MMX_CASE;
extern symbol MMX_COMPOSE;
extern symbol MMX_DECLARE;
extern symbol MMX_DEFINE;
extern symbol MMX_DEFINEALIAS;
extern symbol MMX_DOLLAR;
extern symbol MMX_DOT;
extern symbol MMX_DOTS;
extern symbol MMX_ELSE;
extern symbol MMX_EQUAL;
extern symbol MMX_EQUIV;
extern symbol MMX_ERROR;
extern symbol MMX_EXISTS;
extern symbol MMX_EXPORT;
extern symbol MMX_FACTORIAL;
extern symbol MMX_FOR;
extern symbol MMX_FORALL;
extern symbol MMX_GTR;
extern symbol MMX_GTREQ;
extern symbol MMX_GTRGTR;
extern symbol MMX_HAS;
extern symbol MMX_HOLDS;
extern symbol MMX_IF;
extern symbol MMX_IMPLIES;
extern symbol MMX_IMPORT;
extern symbol MMX_LAMBDA;
extern symbol MMX_LESS;
extern symbol MMX_LESSEQ;
extern symbol MMX_LESSLESS;
extern symbol MMX_LOCAL;
extern symbol MMX_LOOP;
extern symbol MMX_MIGRATE;
extern symbol MMX_MINUS;
extern symbol MMX_MINUSASSIGN;
extern symbol MMX_MODIFY;
extern symbol MMX_NOT;
extern symbol MMX_NOTGTR;
extern symbol MMX_NOTGTREQ;
extern symbol MMX_NOTLESS;
extern symbol MMX_NOTLESSEQ;
extern symbol MMX_NUMBER;
extern symbol MMX_OMINUS;
extern symbol MMX_OOVER;
extern symbol MMX_OPLUS;
extern symbol MMX_OR;
extern symbol MMX_OTIMES;
extern symbol MMX_OVER;
extern symbol MMX_OVERASSIGN;
extern symbol MMX_PLUS;
extern symbol MMX_PLUSASSIGN;
extern symbol MMX_POSTDEC;
extern symbol MMX_POSTINC;
extern symbol MMX_POWER;
extern symbol MMX_PREDEC;
extern symbol MMX_PREINC;
extern symbol MMX_PRIME;
extern symbol MMX_TIMES;
extern symbol MMX_TIMESASSIGN;
extern symbol MMX_SEQAND;
extern symbol MMX_SEQOR;
extern symbol MMX_SQTUPLE;
extern symbol MMX_STEP;
extern symbol MMX_TRANSTYPE;
extern symbol MMX_TUPLE;
extern symbol MMX_TYPE;
extern symbol MMX_UNEQUAL;
extern symbol MMX_UNTIL;
extern symbol MMX_WHILE;
extern symbol MMX_XOR;

/******************************************************************************
* Extra symbols for conversions
******************************************************************************/

extern symbol CONV_FUNCTION;
extern symbol CONV_ARGUMENT;

extern symbol CONV_APPLY;
extern symbol CONV_CROSS;
extern symbol CONV_LAMBDA;
extern symbol CONV_UNALIAS;
extern symbol CONV_UNAND;
extern symbol CONV_UNCROSS;

/******************************************************************************
* Standard types
******************************************************************************/

extern symbol MMX_GENERIC;
extern symbol MMX_VOID;
extern symbol MMX_BOOL;
extern symbol MMX_INT;
extern symbol MMX_STRING;
extern symbol MMX_OSTREAM;
extern symbol MMX_CROSS;
extern symbol MMX_FUNCTION;
extern symbol MMX_ALIAS;
extern symbol MMX_INTEGER;
extern symbol MMX_POLYNOMIAL;

extern symbol MMX_CLASS;

}
#endif // __TOKEN_SYMBOLS_HH
